import shiki from 'shiki';
import visit from 'unist-util-visit';

// A type of promise-like that resolves synchronously and supports only one observer

const _iteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.iterator || (Symbol.iterator = Symbol("Symbol.iterator"))) : "@@iterator";

const _asyncIteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.asyncIterator || (Symbol.asyncIterator = Symbol("Symbol.asyncIterator"))) : "@@asyncIterator";

// Asynchronously call a function and send errors to recovery continuation
function _catch(body, recover) {
	try {
		var result = body();
	} catch(e) {
		return recover(e);
	}
	if (result && result.then) {
		return result.then(void 0, recover);
	}
	return result;
}

var index = (function (_ref, options) {
  var markdownAST = _ref.markdownAST;

  try {
    var _temp3 = function _temp3(_result) {
      if (_exit2) return _result;
      visit(markdownAST, 'code', function (node) {
        node.type = 'html';
        node.children = undefined;

        if (!node.lang) {
          node.value = "<pre class=\"shiki-unknown\"><code>" + node.value + "</code></pre>";
          return;
        }

        node.value = highlighter.codeToHtml(node.value, node.lang);
      });
      return markdownAST;
    };

    var _exit2 = false;
    var theme = options.theme || 'nord';
    var highlighter;

    var _temp4 = _catch(function () {
      return Promise.resolve(shiki.getHighlighter({
        theme: theme,
        langs: options.langs || []
      })).then(function (_shiki$getHighlighter) {
        highlighter = _shiki$getHighlighter;
      });
    }, function () {
      throw new Error('Unable to load theme: ' + theme);
    });

    return Promise.resolve(_temp4 && _temp4.then ? _temp4.then(_temp3) : _temp3(_temp4));
  } catch (e) {
    return Promise.reject(e);
  }
});

export default index;
//# sourceMappingURL=gatsby-remark-shiki.esm.js.map
